// -------------------------------------------------------------------------------
// 
// 		cwCu		Oobt@vO
// 
// 				Ver 3.13f
// 
// -------------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h ------------------------------------------------------------------
#include "DxRingBuffer.h"
#include "DxStatic.h"
#include "DxLib.h"
#include "DxBaseFunc.h"
#include "DxMemory.h"
#include "DxLog.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

// vO --------------------------------------------------------------------

// Oobt@
extern int RingBufInitialize( RINGBUF * RingBuf )
{
	// f[^̏
	_MEMSET( RingBuf, 0, sizeof( RINGBUF ) ) ;
	RingBuf->DataBuffer = NULL ;
	RingBuf->Start = RingBuf->End = 0 ;
	RingBuf->DataLength = 0 ;
	RingBuf->BufferSize = 0 ;
	
	// I
	return 0 ;
}

// Oobt@̌n
extern int RingBufTerminate( RINGBUF * RingBuf )
{
	// f[^mۂĂ
	if( RingBuf->DataBuffer != NULL ) DXFREE( RingBuf->DataBuffer ) ;
	
	// [
	_MEMSET( RingBuf, 0, sizeof( RINGBUF ) ) ;
	
	// I
	return 0 ;
}

// Oobt@Ƀf[^ǉ
extern int RingBufDataAdd( RINGBUF * RingBuf, const void *Data, int Len )
{
	// AhX`FbN
	RingBufAddressCheck( RingBuf ) ;
	
	// f[^܂悤ɃTCY
	if( RingBufReSize( RingBuf, Len ) == -1 )
	{
		DXST_ERRORLOGFMT_ADDUTF16LE(( "\xea\x30\xf3\x30\xb0\x30\xd0\x30\xc3\x30\xd5\x30\xa1\x30\x78\x30\x6e\x30\xc7\x30\xfc\x30\xbf\x30\x6e\x30\xfd\x8f\xa0\x52\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x28\x00\xfd\x8f\xa0\x52\x59\x30\x8b\x30\x77\x95\x55\x30\x20\x00\x25\x00\x64\x00\x20\x00\x62\x00\x79\x00\x74\x00\x65\x00\x29\x00\x00"/*@ L"Oobt@ւ̃f[^̒ǉɎs܂(ǉ钷 %d byte)" @*/, Len )) ;
		return -1 ;
	}

	// QɕĊi[Ȃ΂ȂȂǂŏ𕪊
	if( RingBuf->End + Len > RingBuf->BufferSize )
	{
		// QɕʂĊi[ꍇ̏

		_MEMCPY( (BYTE *)RingBuf->DataBuffer + RingBuf->End, Data,                                                  ( size_t )(         RingBuf->BufferSize - RingBuf->End )   ) ;
		_MEMCPY( RingBuf->DataBuffer,                        (BYTE *)Data + ( RingBuf->BufferSize - RingBuf->End ), ( size_t )( Len - ( RingBuf->BufferSize - RingBuf->End ) ) ) ;
		
		RingBuf->End = Len - ( RingBuf->BufferSize - RingBuf->End ) ;
	}
	else
	{
		// PŊi[ꍇ̏
		
		_MEMCPY( (BYTE *)RingBuf->DataBuffer + RingBuf->End, Data, ( size_t )Len ) ;
		
		RingBuf->End += Len ;
	}
	
	// i[Ăf[^̗ʂ𑝂₷
	RingBuf->DataLength += Len ;

	// I
	return 0 ;
}

// Oobt@f[^ǂ݂
extern int RingBufDataGet( RINGBUF * RingBuf , void *Buf , int Len , int PeekFlag )
{
	// ݂f[^ʂ葽G[
	if( RingBuf->DataLength < Len ) return -1 ;

	// AhX`FbN
	RingBufAddressCheck( RingBuf ) ;

	// QɕʂȂ΂Ȃǂŏ𕪊
	if( RingBuf->Start + Len > RingBuf->BufferSize )
	{
		// Qɕʂꍇ̏
		_MEMCPY( Buf,                                                    (BYTE *)RingBuf->DataBuffer + RingBuf->Start, ( size_t )(         RingBuf->BufferSize - RingBuf->Start )   ) ;
		_MEMCPY( (BYTE *)Buf + ( RingBuf->BufferSize - RingBuf->Start ), RingBuf->DataBuffer,                          ( size_t )( Len - ( RingBuf->BufferSize - RingBuf->Start ) ) ) ;

		if( PeekFlag == FALSE ) RingBuf->Start = Len - ( RingBuf->BufferSize - RingBuf->Start ) ;
	}
	else
	{
		// PŊi[ꍇ̏
		_MEMCPY( Buf, (BYTE *)RingBuf->DataBuffer + RingBuf->Start, ( size_t )Len ) ;
		
		if( PeekFlag == FALSE )  RingBuf->Start += Len ;
	}

	// f[^̗ʂ炷
	if( PeekFlag == FALSE )  RingBuf->DataLength -= Len ;

	// I
	return 0 ;
}

// Oobt@̗Lf[^ʂ̎擾 
extern int RingBufGetDataLength( RINGBUF * RingBuf )
{
	return RingBuf->DataLength ;
}

// Oobt@̎c󂫃f[^̈
extern int RingBufGetRestDataLength( RINGBUF * RingBuf )
{
	return RingBuf->BufferSize - RingBuf->DataLength ;
}

// Oobt@̗eʂwʂ̃f[^ǉĂ܂TCYɒ
extern int RingBufReSize( RINGBUF * RingBuf, int AddSize )
{
	// AhX`FbN
	RingBufAddressCheck( RingBuf ) ;

	// i[f[^݂̃obt@eʂł͓Ȃꍇ̓obt@Ċmۂ
	if( RingBuf->BufferSize < AddSize + RingBuf->DataLength )
	{
		void *OldBuffer ;
		int OldSize ;

		OldBuffer = RingBuf->DataBuffer ;
		OldSize = RingBuf->BufferSize ;

		// TCYĐݒAobt@Ċm
		RingBuf->BufferSize = RingBuf->DataLength * 3 / 2 + AddSize + 1000 ;
		if( ( RingBuf->DataBuffer = ( char * )DXALLOC( ( size_t )RingBuf->BufferSize ) ) == NULL )
		{
			// ĊmۂɎsƂ̃obt@ďI
			DXFREE( OldBuffer ) ;
			_MEMSET( RingBuf, 0, sizeof( RINGBUF ) ) ;
			
			DXST_ERRORLOGFMT_ADDUTF16LE(( "\xea\x30\xf3\x30\xb0\x30\xd0\x30\xc3\x30\xd5\x30\xa1\x30\x6e\x30\x8d\x51\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x28\x00\xba\x78\xdd\x4f\x57\x30\x88\x30\x46\x30\x68\x30\x57\x30\x5f\x30\xb5\x30\xa4\x30\xba\x30\x20\x00\x25\x00\x64\x00\x20\x00\x62\x00\x79\x00\x74\x00\x65\x00\x29\x00\x00"/*@ L"Oobt@̍ĊmۂɎs܂(mۂ悤ƂTCY %d byte)" @*/, RingBuf->BufferSize )) ;
			return -1 ;
		}

		// Ċmۂ̈ɍ܂ł̃obt@̓eRs[
		if( RingBuf->DataLength != 0 )
		{
			if( RingBuf->Start + RingBuf->DataLength > OldSize )
			{
				_MEMCPY( RingBuf->DataBuffer,                                          ( BYTE * )OldBuffer + RingBuf->Start, ( size_t )(                         OldSize - RingBuf->Start )   ) ;
				_MEMCPY( ( BYTE * )RingBuf->DataBuffer + ( OldSize - RingBuf->Start ), OldBuffer,                            ( size_t )( RingBuf->DataLength - ( OldSize - RingBuf->Start ) ) ) ;
			}
			else
			{
				_MEMCPY( RingBuf->DataBuffer, ( BYTE * )OldBuffer + RingBuf->Start, ( size_t )RingBuf->DataLength ) ;
			}
		}

		// AhXĐݒ
		RingBuf->Start = 0 ;
		RingBuf->End = RingBuf->DataLength ;

		// XgpĂ̈
		DXFREE( OldBuffer ) ;
	}
	
	// I
	return 0 ;
}

#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

